\documentclass{article}
\usepackage{pdflscape}
\usepackage[vmargin=0.5in,hmargin=0.5in]{geometry}
\usepackage{color,soul}
\begin{document}
\begin{landscape}
\title{TITLE PENDING}
\author{Sabeeh A. Baig}
\maketitle

<< SETUP, echo = F, results = "hide" >>=
require("knitr")
library(pacman)
pacman::p_load(foreign, KernSmoothIRT, lavaan, plyr, psych, semTools, mirt, sirt, mokken)
options(width = Sys.getenv("COLUMNS"))
options(digits = 3)
options(scipen = 999)
@

<< STUDY 1, TWO-TIER IFA TEST >>=
s1.rm.fact <- 'Time1 = 1-3
                    Time2 = 4-6
                    Time3 = 7-9
'
itemloadings <- rep(1:3, times = 3)

test <- bfactor(s1, itemloadings, s1.rm.fact)
@

<< STUDY 2, TWO-TIER IFA TEST >>=
s2.rm.fact <- 'Time1 = 1-3
                    Time2 = 4-6
                    Time3 = 7-9
                    Time4 = 10-12
                    Time5 = 13-15
                    Time6 = 16-18
                    Time7 = 19-21
'
itemloadings <- rep(1:3, times = 7)

test2 <- bfactor(s2, itemloadings, s2.rm.fact, iterations = 100)
@ 

<< STUDY 1, TWO-TIER IFA >>=
s1.rm.fact <- 'Time1 = 1-3
               Time2 = 4-6
               Time3 = 7-9
'
itemloadings <- rep(1:3, times = 3)

## Construct constraints
### Obtain starting values
start.vals <- bfactor(s1, itemloadings, s1.rm.fact, pars = "values", technical = list(removeEmptyRows = TRUE))

### Setup within repeated-measures constraints
wrmconstr <- start.vals$parnum[(start.vals$name == "a1" | start.vals$name == "a2" | start.vals$name == "a3") & start.vals$est]

### Create constraint list
constraints <- list()
itemnames <- colnames(s1)
pick <- c(0, 3, 6)
for(i in 1:3){

### Impose across time constraints
    constraints[[paste0('slope.', i)]] <- start.vals$parnum[start.vals$name == paste0('a', 3+i) & start.vals$est]
    for(j in 1:4){
        constraints[[paste0('intercept.', i, '_', j)]] <-
            start.vals$parnum[start.vals$name == paste0('d',j) & (start.vals$item %in% itemnames[pick + i]) & start.vals$est]
    }

    constraints[[paste0('Time.', i)]] <- wrmconstr[pick + i]
    
}

### Test of bifactor model
s1.rm.fit <- bfactor(s1, itemloadings, s1.rm.fact, constrain = constraints, technical = list(removeEmptyRows = TRUE))
s1.rm.fit <- bfactor(s1, itemloadings, s1.rm.fact)
summary(s1.rm.fit)
@

\end{landscape}
\end{document}
